package cz.muni.fi.pa165.entity;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import java.util.HashSet;
import java.util.Set;

/**
 * @author mvalko
 */

@Setter
@Getter
@Entity
public class PlayerEntity extends PersonEntity {

    @ManyToOne
    @JoinColumn(name = "team_id_player")
    private TeamEntity team;

    @ManyToMany(mappedBy = "players")
    private Set<MatchEntity> matches = new HashSet<>();

    private int killStat;

    private int deathStat;

    private int assistStat;

    public PlayerEntity() {
    }

    public PlayerEntity(String name){
        super(name);
    }
}
