package cz.muni.fi.pa165.services.team;

import cz.muni.fi.pa165.entity.PlayerEntity;
import cz.muni.fi.pa165.entity.TeamCoachEntity;
import cz.muni.fi.pa165.entity.TeamEntity;

import java.util.List;
import java.util.UUID;

/**
 * @author Dominik Kozubík
 */
public interface TeamService {

    void create(TeamEntity team);

    List<TeamEntity> findAll();

    TeamEntity findById(UUID id);

    UUID update(TeamEntity team);

    void remove(TeamEntity team);

    /**
     * Adds player who recently joined the team to the playerList.
     * @param newPlayer PlayerEntity that is to be added to the playerList.
     */
    void addPlayerToTheTeam(TeamEntity team, PlayerEntity newPlayer);

    /**
     * Removes player who left the team from the playerList.
     * @param oldPlayer PlayerEntity that is to be removed from the playerList.
     */
    void removePlayerFromTheTeam(TeamEntity team, PlayerEntity oldPlayer);

    /**
     * Adds coach who recently joined the team to the coachList.
     * @param newCoach TeamCoachEntity that is to be added to the coachList.
     */
    void addCoachToTheTeam(TeamEntity team, TeamCoachEntity newCoach);

    /**
     * Removes coach who left the team from the coachList.
     * @param oldCoach TeamCoachEntity that is to be removed from the coachList.
     */
    void removeCoachFromTheTeam(TeamEntity team, TeamCoachEntity oldCoach);
}
