package cz.muni.fi.pa165.services.tournamentOrganizer;

import cz.muni.fi.pa165.dao.tournamentOrganizer.TournamentOrganizerDao;
import cz.muni.fi.pa165.entity.TournamentEntity;
import cz.muni.fi.pa165.entity.TournamentOrganizerEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.List;
import java.util.UUID;

/**
 * @author Dominik Kozubík
 */
@Service
@Transactional
public class TournamentOrganizerServiceImpl implements TournamentOrganizerService {

    @Autowired
    private TournamentOrganizerDao tournamentOrganizerDao;

    @Override
    public void create(TournamentOrganizerEntity tournamentOrganizer) {
        if (tournamentOrganizer == null) {
            throw new IllegalArgumentException("Given entity is null.");
        }
        tournamentOrganizerDao.create(tournamentOrganizer);
    }

    @Override
    public List<TournamentOrganizerEntity> findAll() {
        return tournamentOrganizerDao.findAll();
    }

    @Override
    public TournamentOrganizerEntity findById(UUID id) {
        if (id == null) {
            throw new IllegalArgumentException("Given id is null.");
        }
        return tournamentOrganizerDao.findById(id);
    }

    @Override
    public UUID update(TournamentOrganizerEntity tournamentOrganizer) {
        if (tournamentOrganizer == null) {
            throw new IllegalArgumentException("Given entity is null.");
        }
        return tournamentOrganizerDao.update(tournamentOrganizer);
    }

    @Override
    public void remove(TournamentOrganizerEntity tournamentOrganizer) {
        if (tournamentOrganizer == null) {
            throw new IllegalArgumentException("Given entity is null.");
        }
        tournamentOrganizerDao.remove(tournamentOrganizer);
    }

    @Override
    public void addOrganizedTournament(TournamentOrganizerEntity tournamentOrganizer, TournamentEntity organizedT) {
        if (tournamentOrganizer == null || organizedT == null) {
            throw new IllegalArgumentException("Given argument(s) is null.");
        }
        tournamentOrganizer.addOrganizedTournament(organizedT);
    }

    @Override
    public void addFutureTournament(TournamentOrganizerEntity tournamentOrganizer, TournamentEntity futureT) {
        if (tournamentOrganizer == null || futureT == null) {
            throw new IllegalArgumentException("Given argument(s) is null.");
        }
        tournamentOrganizer.addFutureTournament(futureT);
    }
}
